dojo.provide("tests.robot.util");
dojo.require("dojo.io.script");

if (!tests) {
	tests = doh;
}
dojo.getObject("tests.robot", true);

At = function(e) {
	return "at " + e.fileName +":"+ e.lineNumber; 
}

var CapIdx = 1;
Cap = function(filename) {
	CapIdx++;
	var bindArgs = {
        url: "../../testcap.groovy?target="+filename,
		contentType: "text/plain",
        load: dojo.hitch(this, function(data, args) { 
			console.debug("screen capture saved");
			return data;
		}),
        error: dojo.hitch(this, function(type, error) { 
		}),
		putData : "",
		handleAs: "text"        
	};
	var request = dojo.rawXhrPut(bindArgs);		 
}

doh.extend(doh.Deferred, {
	callback: function(res){
		this._check();
		if (this.fixture) this.fixture.endTime = new Date();
		this._resback(res);
	},

	errback: function(res){
		this._check();
		if (this.fixture) {
			Cap(this.fixture.name+"_"+CapIdx);
			this.fixture.endTime = new Date();
		}
		if(!(res instanceof Error)){
			res = new Error(res);
		}
		this._resback(res);		
	}	
});

tests.robot.log = "";
tests.robot.debug = function() {
	var msg = "";
	for(var x=0; x<arguments.length; x++){
		msg += " "+arguments[x];
	}
	tests.robot.log+=msg+"\n";	
};
dojo.connect(doh, "debug", tests.robot.debug);

tests.robot.started = function(group, fixture){
	console.debug ("##Started##", fixture.name);
}

dojo.connect(doh, "_testStarted", tests.robot.started);

tests.robot.finished = function(group, fixture, success){
	var elapsed = fixture.endTime-fixture.startTime;
	console.debug("##Finished##", fixture.name, (success ? "PASSED" : "FAILED"), elapsed, 'ms');
}
dojo.connect(doh, "_testFinished", tests.robot.finished);

dojo.config.useCustomLogger = true;
tests.robot.console = "";
(function(){
	// don't build firebug in iframes
	try{
		if (!console) console = {};
		if(window != window.parent){ 
			// but if we've got a parent logger, connect to it
			if(window.parent["console"]){
				window.console = window.parent.console;
			}
			return; 
		}		
	}catch(e){console.debug("Error setting parent window.console");}
	
	var timeMap = {};
   
    console.log = function(){
			// summary: 
			//		Sends arguments to console.
			logFormatted(arguments, "");
		};
		
    console.debug = function(){
			// summary: 
			//		Sends arguments to console. Missing finctionality to show script line of trace.
			logFormatted(arguments, "debug");
		};
		
    console.info = function(){
			// summary: 
			//		Sends arguments to console, highlighted with (I) icon.
			logFormatted(arguments, "info");
		};
		
	console.warn = function(){
			// summary: 
			//		Sends warning arguments to console, highlighted with (!) icon and blue style.
			logFormatted(arguments, "warning");
		};
		
	console.error = function(){
			// summary: 
			//		Sends error arguments (object) to console, highlighted with (X) icon and yellow style
			//			NEW: error object now displays in object inspector
			logFormatted(arguments, "error");
		};
		
		
	console.time = function(name){
			// summary: 
			//		Starts timers assigned to name given in argument. Timer stops and displays on timeEnd(title);
			//	example:
			//	|	
			//	|	
			//	|	
			//	|	
			timeMap[name] = new Date().getTime();
		};
		
	console.timeEnd = function(name){
			// summary: 
			//		See above.
			if(name in timeMap){
				var delta = (new Date()).getTime() - timeMap[name];
				logFormatted([name+ ":", delta+"ms"], "time");
				delete timeMap[name];
			}
		};
		
	try {
		window.console = console;
	}catch(e){console.debug("Error setting window.console");}
	
	function logFormatted(objects, className){	
		var msg = ""+new Date()+":"+className+": ";
		for(var x=0; x<objects.length; x++){
			msg += " "+objects[x];
		}
		tests.robot.console+=msg+"\n";
			
		if (!tests.robot._updateTimer) {
			tests.robot._updateTimer = setTimeout(function() {
				var data = tests.robot.console;
				tests.robot.console = "";
				tests.robot._updateTimer = null;
				var bindArgs = {
			        url: "../../testreport.groovy",
					contentType: "text/plain",
			        load: function(data, args) { 
						return data;
					},
			        error: function(type, error) { 
						alert("Error saving test output");
					},
					postData : data,
					handleAs: "text"        
				};
				var request = dojo.rawXhrPost(bindArgs);	
			}, 2000);					
		}	
	}
})();

tests.robot.testStartedAt = (new Date()).getTime();
tests.robot.report = function(){
	doh.debug(doh._line);
	doh.debug("| TEST COMPLETED IN: "+((new Date()).getTime()-tests.robot.testStartedAt)+" ms\n");
	doh.debug(doh._line);
	
	if (tests.robot._updateTimer) {
		var data = tests.robot.console;
		tests.robot.console = "";
		clearTimeout(tests.robot._updateTimer);
		tests.robot._updateTimer = null;
		var bindArgs = {
	        url: "../../testreport.groovy",
			contentType: "text/plain",
	        load: function(data, args) { 
				return data;
			},
	        error: function(type, error) { 
				alert("Error saving test output");
			},
			postData : data,
			handleAs: "text",
			sync: true        
		};
		var request = dojo.rawXhrPost(bindArgs);	
	}		
	
	var bindArgs = {
        url: "../../testreport.groovy",
		contentType: "text/plain",
        load: dojo.hitch(this, function(data, args) { 
			console.debug("test results saved");
			return data;
		}),
        error: dojo.hitch(this, function(type, error) { 
			alert("Error saving test results");
		}),
		putData : tests.robot.log,
		handleAs: "text"        
	};
	var request = dojo.rawXhrPut(bindArgs);
	
};
dojo.connect(doh,"_report", tests.robot.report);


tests.robot.util = function() {};

tests.robot.util.getDocTitle = function () {
	return dojo.doc.getElementsByTagName("title")[0].innerHTML;
};

tests.robot.util.getVisibleDialog = function () {
	return tests.robot.util.findFirstVisibleNode(dojo.body(), "dijitDialog");
};

tests.robot.util.findFirstVisibleNode = function (parent, classname, text) {
	return tests.robot.util.findNthVisibleNode(parent, classname, text, 1);
};

tests.robot.util.findNthVisibleNode = function(parent, classname, text, nval) {
	var n = parent.childNodes;
	for(var i=0; (n) && (i<n.length); i++){
		if((n[i].nodeType===1)
			 && (dojo.hasClass(n[i], classname))
			 && (dojo.style(n[i], "visibility")=="visible")
			 && (dojo.style(n[i], "display")!="none"))
		{
			if (!text || (n[i].innerHTML && (n[i].innerHTML.indexOf(text) >= 0))) {
				nval --;
				if (nval <= 0) {
			   		return n[i];
				}	
			}
		}
		var res = tests.robot.util.findNthVisibleNode(n[i], classname, text, nval);
		if (res) return res;
	}	
	return res;	
};

tests.load = function(module, props) {
	dojo.setObject(module,props);
	var loc = ""+dojo.moduleUrl(module);
	if(loc.lastIndexOf("/") == loc.length-1){
		loc = loc.substr(0,loc.length-1);
	}
	dojo.io.script.attach(module,loc+".js");
}

	